#######################################################################
##### Makefile for the VortexGE 3rd Party Library (lua)           #####
##### Copyright (C) 2004-2006 Aloysius Indrayanto                 #####
##### GNU Lesser General Public License                           #####
##### ----------------------------------------------------------- #####
##### EDITING THIS FILE ERRONEOUSLY MAY CAUSE THE SCRIPT TO FAIL  #####
##### ----------------------------------------------------------- #####
##### This program is distributed WITHOUT ANY WARRANTY.           #####
##### See the GNU Lesser General Public License for more details. #####
#######################################################################

##### Use BASH ########################################################
SHELL = /bin/bash

##### Include the Needed Files ########################################
include ../../buildScript/Config
include ../../buildScript/Script

##### Macros ##########################################################
VGLD = ../../../lib
INCS = -I${VGLD}

##### Compile the zlib source files ###################################
TOBJ = lapi.o    lcode.o   ldo.o     lgc.o    lmathlib.o lopcodes.o lstring.o \
		   ltablib.o lvm.o     lauxlib.o ldblib.o ldump.o    linit.o    lmem.o    \
		   lparser.o lstrlib.o ltm.o     lzio.o   lbaselib.o ldebug.o   lfunc.o   \
		   llex.o    lobject.o lstate.o  ltable.o lundump.o

compileAll: tstatic tshared
	@echo "[1;32m### MAKE LUA ........... SUCCESSFULLY COMPLETED[0m"

##### Static library
ifeq (${BLDA},1)
tstatic: ${TOBJ}
else
tstatic:
endif
	@echo > /dev/null

%.o: *.h %.c
	@echo "[1;34mCompiling lua source file .................[0m $@"
	@${GNUC} ${GCCO} -DLUA_USE_LINUX -c ${@:%.o=%.c} -o $@

##### Shared library (all)
ifeq (${BLDS},1)
tshared: ${TOBJ:%.o=%.lo}
else
tshared:
endif
	@echo > /dev/null

##### Shared library (without PIC)
ifeq ($(strip ${OPSO}),)
%.lo: %.o *.h %.c
	@echo "[0;36mCompiling lua source file .................[0m $@"
	@cp -f ${@:%.lo=%.o} $@
##### Shared library (with PIC)
else
%.lo: *.h %.c
	@echo "[1;34mCompiling lua source file .................[0m $@"
	@${GNUC} ${OPSO} ${GCCO} -DLUA_USE_LINUX -c ${@:%.lo=%.c} -o $@
endif

##### Cleanup #########################################################
clean:
	@echo "[1;31mRemoving lua object files .......................[0m"
	@rm -f *.o *.lo *.s

#######################################################################
