// ############################################################################################
//  SimpleMQClient.cc
//  A demo application for VortexGE
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This program is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################

// VortexGE headers
#include <VMain.h>


// Main program
int main()
{
  // Local variables
  CMQClient csClient;
  char      cKey, acData[64];
  uint32_t  un32Cnt, aun32CID[_MAX_MQ_CLIENT_], un32CID;

  // Initialization
  VClrScr();
  csClient.Connect("DEMO MQ SERVER");
  VEnableGetChar(true);
  VEnableDebugPrint(true);

  // Ask server for previously running clients
  if(csClient.EnumerateByUID(aun32CID, NULL)) {
    VPrint("Found previously connected client(s) :\n");
    snprintf(acData, sizeof(acData), "Hi, I am %08X !", csClient.GetCID());
    for(un32Cnt = 0; un32Cnt < _MAX_MQ_CLIENT_; un32Cnt++) {
      if(aun32CID[un32Cnt]) {
        VPrint("   CID %08X\n", aun32CID[un32Cnt]);
        csClient.CC2CSend(aun32CID[un32Cnt], 0, acData, 20);
      }
      else
        break;
    }
  }

  // Client loop
  VPrint("Client is running, press 'x' to exit ...\n");
  for(;;) {
    cKey = VGetChar();
    if((cKey == 'x') || (cKey == 'X')) break;

    if(csClient.GotShutDownNotification()) break;
    if(csClient.CC2CReceive(&un32CID, 0, acData, 20))
      VPrint("Received message from CID %08X : %s\n", un32CID, acData);

    usleep(100000);
  }

  // Shut down client
  VEnableGetChar(false);
  csClient.Disconnect();
  return(0);
}
