// ############################################################################################
//  SpecialClasses.cc
//  Implementation of some special purpose classes
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This library is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################

// VortexGE headers
#include "../Base/MessageDisplayer.h"
#include "../System/FatalSignalHandler.h"
#include "SpecialClasses.h"


namespace vge {

//
// CCanAbortOnDestruction implementation
//
CCanAbortOnDestruction::CCanAbortOnDestruction(bool abortOnDestruction)
: _abod(abortOnDestruction), _ctype("CCanAbortOnDestruction")
{
}

CCanAbortOnDestruction::~CCanAbortOnDestruction() throw()
{
  vassert(!_abod,
          "Class instance %p of type %s is currently not allowed to be destructed (deleted)",
          reinterpret_cast<void*>(this), _ctype.c_str());
}

} // namespace vge
