// ############################################################################################
//  roomedit-DlgPages-Main-SCut.cc
//  Implementation of roomedit's CPage_Main class
//  (keyboard shortcuts' event handlers)
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This program is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################

// roomedit's headers
#include "roomedit-DlgPages-Main.h"


//
// Our main dialog page: keyboard shortcuts's event handlers
//
void CPage_Main::_onKscCamFollow()
{
  if(!rdoCamFollow.GetEnable() || rdoCamFollow.GetValue()) return;
  rdoCamFollow.SetValue(true); rdoCamFollow.DrawControl();
  rdoCamFree.SetValue(false);  rdoCamFree.DrawControl();
  _onRdoCamFollowFree(NULL);
}

void CPage_Main::_onKscCamFree()
{
  if(!rdoCamFree.GetEnable() || rdoCamFree.GetValue()) return;
  rdoCamFollow.SetValue(false); rdoCamFollow.DrawControl();
  rdoCamFree.SetValue(true);    rdoCamFree.DrawControl();
  _onRdoCamFollowFree(NULL);
}

void CPage_Main::_onKscCamMovPos()
{
  if(!chkCamFreePos.GetEnable()) return;
  chkCamFreePos.SetValue(!chkCamFreePos.GetValue());
  chkCamFreePos.DrawControl();
  _iVideoEnv->UpdateDisplay();
}

void CPage_Main::_onKscCamMovTrg()
{
  if(!chkCamFreeTrg.GetEnable()) return;
  chkCamFreeTrg.SetValue(!chkCamFreeTrg.GetValue());
  chkCamFreeTrg.DrawControl();
  _iVideoEnv->UpdateDisplay();
}

void CPage_Main::_onKscMovCurObj()
{
  if(!rdoMovCurObj.GetEnable() || rdoMovCurObj.GetValue()) return;
  rdoMovCurObj.SetValue(true);   rdoMovCurObj.DrawControl();
  rdoMovCurOnly.SetValue(false); rdoMovCurOnly.DrawControl();
  rdoMovCam.SetValue(false);     rdoMovCam.DrawControl();
  _onRdoMovCurObj(NULL);
}

void CPage_Main::_onKscMovCurOnly()
{
  if(!rdoMovCurOnly.GetEnable() || rdoMovCurOnly.GetValue()) return;
  rdoMovCurObj.SetValue(false); rdoMovCurObj.DrawControl();
  rdoMovCurOnly.SetValue(true); rdoMovCurOnly.DrawControl();
  rdoMovCam.SetValue(false);    rdoMovCam.DrawControl();
  _iVideoEnv->UpdateDisplay();
}

void CPage_Main::_onKscMovCam()
{
  if(!rdoMovCam.GetEnable() || rdoMovCam.GetValue()) return;
  rdoMovCurObj.SetValue(false);  rdoMovCurObj.DrawControl();
  rdoMovCurOnly.SetValue(false); rdoMovCurOnly.DrawControl();
  rdoMovCam.SetValue(true);      rdoMovCam.DrawControl();
  _iVideoEnv->UpdateDisplay();
}
